- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# OsiFmpSolverInterface Class Reference

OSL Solver Interface. More...

`#include <OsiFmpSolverInterface.hpp>`

Inheritance diagram for OsiFmpSolverInterface:

[legend]
Collaboration diagram for OsiFmpSolverInterface:

[legend]
List of all members.

## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
bool | setDblParam (OsiDblParam key, double value)
bool | setStrParam (OsiStrParam key, const std::string &value)
bool | getIntParam (OsiIntParam key, int &value) const
bool | getDblParam (OsiDblParam key, double &value) const
bool | getStrParam (OsiStrParam key, std::string &value) const
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colNumber) const
| Return true if column is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use DBL_MAX for infinity.
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes setRowLower() and setRowUpper().
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes setRowLower() and setRowUpper() over and over again.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes setRowType() over and over again.
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename - returns number of errors (see OsiMpsReader class).
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
Constructors and destructors
| OsiFmpSolverInterface ()
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiFmpSolverInterface (const OsiFmpSolverInterface &)
| Copy constructor.
OsiFmpSolverInterface & | operator= (const OsiFmpSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiFmpSolverInterface ()
| Destructor.
virtual void | reset ()
| Resets as if default constructor.
## Protected Member Functions
void | AllocSolutionSpace ()
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut (append to constraint matrix).
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (adjust one or more bounds).
## Static Protected Member Functions
static int | CBIterCountP2 (int iter, double obj)
## Private Member Functions
Private methods
void | gutsOfDestructor ()
| The real work of a copy constructor (used by copy and assignment).
void | freeCachedResults ()
| The real work of a destructor (used by copy and assignment).
void | extractSenseRhsRange () const
| A method that fills up the rowsense_, rhs_ and rowrange_ arrays.
## Private Attributes
Private member data
int | nr_
| Number of rows in the matrix.
int | nc_
int | nz_
int | ns_
int | nq_
int * | send_
int * | sref_
| Number of rows in the matrix.
int * | sfun_
| Number of rows in the matrix.
int * | sbeg_
| Number of rows in the matrix.
int * | rowin_
int * | colin_
double * | aij_
int * | mitype_
double * | upb_
double * | lob_
double * | cost_
double * | rhs_
double * | lhs_
int | stsl_
int * | basis_
double * | sol_
double * | dsl_
double | objconstant_
double | obj_
std::string | modelname_
bool | isMax_
Cached information derived from the FortMP model
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rowrhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByColumn_
| Pointer to column-wise copy of problem matrix coefficients.
CoinWarmStartBasis * | ws_
| A pointer to the warmstart information to be used in the hotstarts.
int | itlimOrig_
| The original iteration limit before hotstarts started.
## Friends
void | OsiFmpSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiFmpSolverInterface class.

## Detailed Description

OSL Solver Interface.

Instantiation of OsiFmpSolverInterface for FortMP

Definition at line 25 of file OsiFmpSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiFmpSolverInterface::OsiFmpSolverInterface | ( |  | ) |

Default Constructor.

OsiFmpSolverInterface::OsiFmpSolverInterface | ( | const OsiFmpSolverInterface & |  | ) |

Copy constructor.

virtual OsiFmpSolverInterface::~OsiFmpSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiFmpSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiFmpSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiFmpSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiFmpSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiFmpSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiFmpSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

bool OsiFmpSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

CoinWarmStart* OsiFmpSolverInterface::getEmptyWarmStart | ( |  | ) | const`[inline, virtual]`

Get empty warm start object.

Implements OsiSolverInterface.

Definition at line 95 of file OsiFmpSolverInterface.hpp.

virtual CoinWarmStart* OsiFmpSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiFmpSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiFmpSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiFmpSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiFmpSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiFmpSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiFmpSolverInterface::isContinuous | ( | int | colNumber | ) | const`[virtual]`

Return true if column is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiFmpSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiFmpSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiFmpSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getRowPrice | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getReducedCost | ( |  | ) | const`[virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiFmpSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiFmpSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiFmpSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiFmpSolverInterface::getDualRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiFmpSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound
Use -DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound
Use DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound
Use -DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound
Use DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single row lower and upper bound
The default implementation just invokes setRowLower() and setRowUpper().

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of rows simultaneously
The default implementation just invokes setRowLower() and setRowUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a number of rows simultaneously
The default implementation just invokes setRowType() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose any characteristics changes
  | senseList | the new senses
  | rhsList | the new right hand sides
  | rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiFmpSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename - returns number of errors (see OsiMpsReader class).

Reimplemented from OsiSolverInterface.

virtual void OsiFmpSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

virtual OsiSolverInterface* OsiFmpSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiFmpSolverInterface& OsiFmpSolverInterface::operator= | ( | const OsiFmpSolverInterface & | rhs | ) |

Assignment operator.

virtual void OsiFmpSolverInterface::reset | ( |  | ) | `[virtual]`

Resets as if default constructor.

Reimplemented from OsiSolverInterface.

static int OsiFmpSolverInterface::CBIterCountP2 | ( | int | iter,
|  | double | obj |
| ) |  |  | `[static, protected]`

void OsiFmpSolverInterface::AllocSolutionSpace | ( |  | ) | `[protected]`

virtual void OsiFmpSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut (append to constraint matrix).

Implements OsiSolverInterface.

virtual void OsiFmpSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (adjust one or more bounds).

Implements OsiSolverInterface.

void OsiFmpSolverInterface::gutsOfDestructor | ( |  | ) | `[private]`

The real work of a copy constructor (used by copy and assignment).

void OsiFmpSolverInterface::freeCachedResults | ( |  | ) | `[private]`

The real work of a destructor (used by copy and assignment).

void OsiFmpSolverInterface::extractSenseRhsRange | ( |  | ) | const`[private]`

A method that fills up the rowsense_, rhs_ and rowrange_ arrays.

## Friends And Related Function Documentation

void OsiFmpSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiFmpSolverInterface class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging. Also, if this method is compiled with optimization, the compilation takes 10-15 minutes and the machine pages (has 256M core memory!)...

## Member Data Documentation

int OsiFmpSolverInterface::nr_`[private]`

Number of rows in the matrix.

Definition at line 644 of file OsiFmpSolverInterface.hpp.

int OsiFmpSolverInterface::nc_`[private]`

Number of columns in the matrix

Definition at line 646 of file OsiFmpSolverInterface.hpp.

int OsiFmpSolverInterface::nz_`[private]`

Number of non zeroes in the matrix

Definition at line 648 of file OsiFmpSolverInterface.hpp.

int OsiFmpSolverInterface::ns_`[private]`

Number of SOS

Definition at line 650 of file OsiFmpSolverInterface.hpp.

int OsiFmpSolverInterface::nq_`[private]`

Number of elements in the Q matrix

Definition at line 652 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::send_`[private]`

SOS related vectors

Definition at line 654 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::sref_`[private]`

Number of rows in the matrix.

Definition at line 655 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::sfun_`[private]`

Number of rows in the matrix.

Definition at line 656 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::sbeg_`[private]`

Number of rows in the matrix.

Definition at line 657 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::rowin_`[private]`

Vector of row indices of the non zeros (cardinality nz)

Definition at line 659 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::colin_`[private]`

Vector of column indices of the non zeros (cardinality nz)

Definition at line 661 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::aij_`[private]`

Vector containing the non zeroes values (cardinality nz)

Definition at line 663 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::mitype_`[private]`

Vector containing the types of each column: 0 continuos, 1 integer, 2 binary (cardinality nc)

Definition at line 665 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::upb_`[private]`

Vector of the variables upper bounds (cardinality nc)

Definition at line 667 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::lob_`[private]`

Vector of the variables lower bounds (cardinality nc)

Definition at line 669 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::cost_`[private]`

Vector of the cost coefficients (cardinality nc)

Definition at line 671 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::rhs_`[private]`

Right hand side vector (cardinality nr)

Definition at line 673 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::lhs_`[private]`

left hand hand side vector (cardinality nr)

Definition at line 675 of file OsiFmpSolverInterface.hpp.

int OsiFmpSolverInterface::stsl_`[private]`

Solution status

Definition at line 677 of file OsiFmpSolverInterface.hpp.

int* OsiFmpSolverInterface::basis_`[private]`

Basis status vector

Definition at line 679 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::sol_`[private]`

Primal Solution vector

Definition at line 681 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::dsl_`[private]`

Dual Solution vector

Definition at line 683 of file OsiFmpSolverInterface.hpp.

double OsiFmpSolverInterface::objconstant_`[private]`

constant in the objective function (scalar)

Definition at line 685 of file OsiFmpSolverInterface.hpp.

double OsiFmpSolverInterface::obj_`[private]`

the final objective function value

Definition at line 687 of file OsiFmpSolverInterface.hpp.

std::string OsiFmpSolverInterface::modelname_`[private]`

model name

Definition at line 689 of file OsiFmpSolverInterface.hpp.

bool OsiFmpSolverInterface::isMax_`[private]`

optimisation directrion

Definition at line 691 of file OsiFmpSolverInterface.hpp.

char* OsiFmpSolverInterface::rowsense_`[mutable, private]`

Pointer to dense vector of row sense indicators.

Definition at line 697 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::rowrhs_`[mutable, private]`

Pointer to dense vector of row right-hand side values.

Definition at line 700 of file OsiFmpSolverInterface.hpp.

double* OsiFmpSolverInterface::rowrange_`[mutable, private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 704 of file OsiFmpSolverInterface.hpp.

CoinPackedMatrix* OsiFmpSolverInterface::matrixByRow_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 707 of file OsiFmpSolverInterface.hpp.

CoinPackedMatrix* OsiFmpSolverInterface::matrixByColumn_`[mutable, private]`

Pointer to column-wise copy of problem matrix coefficients.

Definition at line 709 of file OsiFmpSolverInterface.hpp.

CoinWarmStartBasis* OsiFmpSolverInterface::ws_`[private]`

A pointer to the warmstart information to be used in the hotstarts.

Reimplemented from OsiSolverInterface.

Definition at line 713 of file OsiFmpSolverInterface.hpp.

int OsiFmpSolverInterface::itlimOrig_`[private]`

The original iteration limit before hotstarts started.

Definition at line 715 of file OsiFmpSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Bcps-0.91.0/Osi/src/OsiFmp/OsiFmpSolverInterface.hpp